//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     clrDimGray
#property indicator_color2     clrLimeGreen
#property indicator_color3     clrPaleVioletRed
#property indicator_color4     clrLimeGreen
#property indicator_color5     clrPaleVioletRed
#property indicator_width1     1
#property indicator_width2     3
#property indicator_width3     3
#property indicator_minimum    -100
#property indicator_maximum    100
#property indicator_levelcolor clrDarkSlateGray
#property strict

enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};

extern enTimeFrames       TimeFrame        = tf_cu;            // Time frame
extern int                TimeFrameCustom  = 0;                // Custom time frame to use (if custom time frame used)
extern int                AroonPeriod      = 25;               // Aroon period
extern int                MaPeriod         = 14;               // MA period
extern ENUM_MA_METHOD     MaMethod         = MODE_EMA;         // MA method to use
extern ENUM_APPLIED_PRICE PriceHigh        = PRICE_HIGH;       // Price to use for high
extern ENUM_APPLIED_PRICE PriceLow         = PRICE_LOW;        // Price to use for low
extern int                Filter           = 50;               // Aroon filter
extern bool               alertsOn         = false;            // Turn alerts on?
extern bool               alertsOnCurrent  = false;            // Alerts on current (stil opened) bar?
extern bool               alertsMessage    = true;             // Alerts should display a message?
extern bool               alertsSound      = false;            // Alerts should play a sound?
extern bool               alertsEmail      = false;            // Alerts should send email?
extern bool               arrowsVisible    = false;            // Arrows visible?
extern string             arrowsIdentifier = "aroon Arrows1";  // Unique ID for arrows
extern double             arrowsUpperGap   = 0.5;              // Upper arrow gap
extern double             arrowsLowerGap   = 0.5;              // Lower arrow gap
extern color              arrowsUpColor    = clrLimeGreen;     // Up arrow color
extern color              arrowsDnColor    = clrOrange;        // Down arrow color
extern int                arrowsUpCode     = 241;              // Up arrow code
extern int                arrowsDnCode     = 242;              // Down arrow code
extern bool               arrowsOnFirst    = true;             // Arrows on first bar?
extern bool               Interpolate      = true;             // Interpolate in multi time mode?
 
//
//
//
//
//

double osc[];
double osclu[];
double oscld[];
double oscau[];
double oscad[];
double trend[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,osc);
   SetIndexBuffer(1,osclu);
   SetIndexBuffer(2,oscld);
   SetIndexBuffer(3,oscau); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,oscad); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,108);
   SetIndexBuffer(5,trend);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);

         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99; 
         if (TimeFrameCustom==0) TimeFrameCustom = MathMax(TimeFrameCustom,_Period);
         if (TimeFrame!=tf_cus)
               TimeFrame = MathMax(TimeFrame,_Period);
         else  TimeFrame = (enTimeFrames)TimeFrameCustom;
   
   IndicatorShortName("Aroon oscillator ("+(string)AroonPeriod+")");
   return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double prices[][2];
#define _high 0
#define _low  1
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { osc[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame!=_Period)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     osc[i]   = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,AroonPeriod,MaPeriod,MaMethod,PriceHigh,PriceLow,Filter,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,0,y); 
                     trend[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,AroonPeriod,MaPeriod,MaMethod,PriceHigh,PriceLow,Filter,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,5,y); 
                     
                     //
                     //
                     //
                     //
                     //
               
                     if (!Interpolate || (i>0 &&y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                     //
                     //
                     //
                     //
                     //
 
                     int n,j; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                        for(j = 1; i+n < Bars && i+j < Bars && j < n; j++) osc[i+j] = osc[i] + (osc[i+n] - osc[i]) * j/n;
               }
               for (int i=limit;i>=0; i--) 
               {
                  osclu[i] = EMPTY_VALUE;
                  oscld[i] = EMPTY_VALUE;
                  oscau[i] = EMPTY_VALUE;
                  oscad[i] = EMPTY_VALUE;
                     if (trend[i] ==  1) { osclu[i] = osc[i]; if (i<(Bars-1) && trend[i]!=trend[i+1]) oscau[i] = osc[i]; }
                     if (trend[i] == -1) { oscld[i] = osc[i]; if (i<(Bars-1) && trend[i]!=trend[i+1]) oscad[i] = osc[i]; }
                     if (arrowsVisible)
                     {
                        string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);            
                        if (i<(Bars-1) && trend[i] != trend[i+1])
                        {
                           if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                           if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
                        }
                     }
               }
               return(0);
            }

   //
   //
   //
   //
   //
   
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
   for(int i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      prices[r][_high] = iMA(NULL,0,MaPeriod,0,MaMethod,PriceHigh,i);
      prices[r][_low ] = iMA(NULL,0,MaPeriod,0,MaMethod,PriceLow ,i);
         double max = prices[r][_high]; double maxi = 0;
         double min = prices[r][_low ]; double mini = 0;
         for (int k=1; k<=AroonPeriod && (r-k)>=0; k++)
         {
             if (max<prices[r-k][_high]) { maxi=k; max = prices[r-k][_high]; }
             if (min>prices[r-k][_low ]) { mini=k; min = prices[r-k][_low ]; }
         }                  
         osc[i]   = 100.0*(mini-maxi)/AroonPeriod;   
         osclu[i] = EMPTY_VALUE;
         oscld[i] = EMPTY_VALUE;
         oscau[i] = EMPTY_VALUE;
         oscad[i] = EMPTY_VALUE;
         if (r>0)
         {
            trend[i] = trend[i+1];
               if (osc[i] >  Filter)                     trend[i] =  1;
               if (osc[i] < -Filter)                     trend[i] = -1;
               if (osc[i] <  Filter && osc[i] > -Filter) trend[i] = 0;
               if (trend[i] ==  1) { osclu[i] = osc[i]; if (trend[i]!=trend[i+1]) oscau[i] = osc[i]; }
               if (trend[i] == -1) { oscld[i] = osc[i]; if (trend[i]!=trend[i+1]) oscad[i] = osc[i]; }
               if (arrowsVisible)
               {
                  string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);            
                  if (trend[i] != trend[i+1])
                  {
                     if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                     if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
                  }
               }
         }               
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int forBar = 1; if (alertsOnCurrent) forBar = 0;
         if (oscau[forBar]!= EMPTY_VALUE) doAlert("Arron oscillator trend chaned to UP");
         if (oscad[forBar]!= EMPTY_VALUE) doAlert("Arron oscillator trend chaned to DOWN");
   }      
   return(0);
}


//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Aroon oscillator - ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail("Arron oscillator",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i);   
   int    add  = 0; if (!arrowsOnFirst) add = TimeFrame*60-1;
   
      //
      //
      //
      //
      //

      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[MathMax(iBarShift(NULL,0,Time[i]+add),0)] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[MathMax(iBarShift(NULL,0,Time[i]+add),0)]  - arrowsLowerGap * gap);
}